#! /usr/bin/env python
# ePycycle bot

import string
from ircbot import SingleServerIRCBot
from irclib import nm_to_n, irc_lower

BotRoot = "Leonidas"
#BotAdmin = "ADM"
#BotOp = "BOP"

AdminList = []
OpList = []
GeneralList = []

helpMessage = """Zeile 1
Zeile 2"""
class ePyCycle(SingleServerIRCBot):
	def __init__(self, server, port, nickname, channel, realname, recon):
		SingleServerIRCBot.__init__(self, [(server, port)], nickname, realname, recon)
		self.channel = channel
		self.start()

	def on_welcome(self, connection, event):
		connection.join(self.channel)
		
	def on_privmsg(self, connection, event):
		# in simpleuser[0] ist der nick
		simpleuser = string.split(event.source(), "!", 1)
		#print simpleuser[0]
		if self.is_in_list(simpleuser[0], GeneralList) == 0:
			print "Command by General User"
			self.gencmd(simpleuser[0], event.arguments()[0], connection)
			self.normcmd(simpleuser[0], event.arguments()[0], connection)
		elif self.is_in_list(simpleuser[0], OpList) == 0:
			print "Command by BotOperator"
			self.opcmd(simpleuser[0], event.arguments()[0], connection)
			self.gencmd(simpleuser[0], event.arguments()[0], connection)
			self.normcmd(simpleuser[0], event.arguments()[0], connection)
		elif self.is_in_list(simpleuser[0], AdminList) == 0:
			print "Command by BotAdmin"
			self.admcmd(simpleuser[0], event.arguments()[0], connection)
			self.opcmd(simpleuser[0], event.arguments()[0], connection)
			self.gencmd(simpleuser[0], event.arguments()[0], connection)
			self.normcmd(simpleuser[0], event.arguments()[0], connection)
		elif simpleuser[0] == BotRoot:
			print "Command by BotRoot"
			self.brcmd(simpleuser[0], event.arguments()[0], connection)
			self.admcmd(simpleuser[0], event.arguments()[0], connection)
			self.opcmd(simpleuser[0], event.arguments()[0], connection)
			self.gencmd(simpleuser[0], event.arguments()[0], connection)
			self.normcmd(simpleuser[0], event.arguments()[0], connection)
		else:
			print "Command by Normal User"
			self.normcmd(simpleuser[0], event.arguments()[0], connection)
	def gencmd(self, user, command, connection):
		pass
	def admcmd(self, user, command, connection):
		pass
	def opcmd(self, user, command, connection):
		pass
	def normcmd(self, user, command, connection):
		if command == "help":
			connection.notice(user, "This is not build in yet-Sai")
			#connection.notice(user, helpMessage)
	
	def brcmd(self, user, command, connection):
		"""BotRoot Command - Executes BotRoot's Commands
		"""
		lists = access()
		if command == "list":
			lists.list(user, connection)
		elif command == "die":
			self.die()
		elif command == "save":
			lists.save()
		elif command == "load":
			connection.notice(user, "This is internal and should be used carefull")
			lists.load()
		elif command == "debug":
			connection.notice(user, "This is only debug stuff, look on stdout")
			print "GeneralList: ",
			print GeneralList
			print "AdminList: ",
			print AdminList
			print "OpList: ",
			print OpList
			print helpMessage
		elif command == "restart":
			self.disconnect()
		elif command[:3] == "add":
			addwho = command[4:]
			added = string.split(addwho, " ", 1)
			print "User: ",
			print added[0]
			print "Status: ",
			print added[1]
			success = lists.add(added[0], added[1])
			if success != 0:
				connection.notice(user, "Something went wrong!")
		elif command[:6] == "remove":
			removewho = command[7:]
			if lists.remove(removewho) != 0:
				connection.notice(user, "No such user")
		elif command[:6] == "status":
			statwho = command[7:]
			if lists.gettype(statwho) == "admin":
				connection.notice(user, "User is Admin")
			elif lists.gettype(statwho) == "op":
				connection.notice(user, "User is Operator")
			elif lists.gettype(statwho) == "general":
				connection.notice(user, "User is a general user")
			else:
				connection.notice(user, "User is a normal user")
				
	def is_in_list(self, user, list):
		if list.count(user) != 0:
			return 0
		else:
			return 1
			
class access:
	def __init__(self):
		#Load Users
		self.load()
	def add(self, user, status):
		if status == "admin":
			AdminList.append(user)
			#Save the list, it'll be reloaded on next __init__
			self.save()
			return 0
		elif status == "op":
			OpList.append(user)
			self.save()
			return 0
		elif status == "general":
			GeneralList.append(user)
			self.save()
			return 0
		else:
			return 1
	def remove(self, user):
		# Search user in the lists
		if AdminList.count(user) == 0:
			if OpList.count(user) == 0:
				if GeneralList.count(user) == 0:
					#not found in any
					return 1
				else:
					#Found in general and removing
					GeneralList.remove(user)
					self.save()
					return 0
			else:
				#found in op, remove
				OpList.remove(user)
				self.save()
				return 0
		else:
			#found in Admin, remove
			AdminList.remove(user)
			self.save()
			return 0

	def gettype(self, user):
		if AdminList.count(user) == 0:
			if OpList.count(user) == 0:
				if GeneralList.count(user) == 0:
					#No special user
					return "normal"
				else:
					#General user
					return "general"
			else:
				#user is op
				return "op"
		else:
			#user is admin
			return "admin"
			
	def list(self, user, connection):
		for nick in AdminList:
			sendnick = self.rfill(nick, 20)
			sendnick = sendnick + "Admin"
			connection.notice(user, sendnick)
		for nick in OpList:
			sendnick = self.rfill(nick, 20)
			sendnick = sendnick + "Operator"
			connection.notice(user, sendnick)
		for nick in GeneralList:
			sendnick = self.rfill(nick, 20)
			sendnick = sendnick + "General User"
			connection.notice(user, sendnick)
	def load(self):
		self.del_lists()
		oplst = file("oplist.txt", "r")
		admlst = file("adminlist.txt", "r")
		genlst = file("genlist.txt", "r")
		
		op = 1
		while op:
			who = oplst.readline()
			if who == "":
				#EOF - go out
				op = 0
			else:
				who = who.splitlines()[0]
				OpList.append(who)
				
		adm = 1
		while adm:
			who = admlst.readline()
			if who == "":
				#EOF - go out
				adm = 0
			else:
				who = who.splitlines()[0]
				AdminList.append(who)
				
		gen = 1
		while gen:
			who = genlst.readline()
			if who == "":
				#print "Who is ['']"
				gen = 0
			else:
				#print "OkAy"
				who = who.splitlines()[0]
				GeneralList.append(who)
				#print "This GenList: ",
				#print GeneralList
				
	def del_lists(self):
		#Delete entire AccessLists
		
		lg = len(GeneralList)
		#print "Len of GenList:",
		#print lg
		
		if lg != 0:
			lg_not_zero = 1
			while lg_not_zero:
				lg = lg - 1
				#print "Now lg:",
				#print lg
				GeneralList.pop(lg)
				#print "Now GenList:",
				#print GeneralList
				#lg = lg - 1
				if lg == 0:
					lg_not_zero = 0
		
		la = len(AdminList)
		if la != 0:
			la_not_zero = 1
			while la_not_zero:
				la = la - 1
				AdminList.pop(la)
				if la == 0:
					la_not_zero = 0
					
		lo = len(OpList)
		if lo != 0:
			lo_not_zero = 1
			while lo_not_zero:
				lo = lo - 1
				OpList.pop(lo)
				if lo == 0:
					lo_not_zero = 0
		
	def save(self):
		oplst = file("oplist.txt","w")
		for nick in OpList:
			oplst.write(nick + "\n")
		oplst.close()
		admlst = file("adminlist.txt","w")
		for nick in AdminList:
			admlst.write(nick + "\n")
		admlst.close()
		genlst = file("genlist.txt", "w")
		for nick in GeneralList:
			genlst.write(nick + "\n")
		genlst.close()
		
	def rfill(self, string_to_fill, lenght):
		"""Fills the string until it is <lenght> long
		"""
		#Attention! Character is not a space it is a ALT+255
		character = ""
		strlen = len(string_to_fill)
		strlen = lenght - strlen
		strlen_not_zero = 1
		while strlen_not_zero:
			string_to_fill = string_to_fill + character
			strlen = strlen -1
			if strlen == 0:
				strlen_not_zero = 0
		return string_to_fill

def main():
	options = loadsettings()
	print "Server: " + options[0]
	print "Port: " + str(options[1])
	print "Nickname: " + options[2]
	print "Realname: " + options[4]
	print "Channel: " + options[3]
	print "Reconnect: " + str(options[5]) + "sec" 
	
	bot = ePyCycle(options[0], options[1], options[2], options[3], options[4], options[5])
	bot.start()
	
def loadsettings():
	import sys
	settings_in = "epycycle.cfg"
	try:
		settings = file(settings_in, "r")
	except:
		print "Couldn't open %s, Sai. Creating an empty one for you..." % (settings_in)
		settings = file(settings_in, "w")
		settings.close()
		sys.exit(100)
	
	#Get settings
	set_server = settings.readline()
	set_port = settings.readline()
	set_nickname = settings.readline()
	set_realname = settings.readline()
	set_channel = settings.readline()
	set_recon = settings.readline()
	
	# Remove newlines
	set_server = set_server.splitlines()[0]
	set_port = set_port.splitlines()[0]
	set_nickname = set_nickname.splitlines()[0]
	set_realname = set_realname.splitlines()[0]
	set_channel = set_channel.splitlines()[0]
	set_recon = set_recon.splitlines()[0]
	
	set_port = int(set_port)
	set_recon = int(set_recon)
	# make a list
	set_all = [set_server, set_port, set_nickname, set_channel, set_realname, set_recon]
	#print set_all
	
	return set_all
	
if __name__ == "__main__": main()